﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=8.5
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: true
#End Region

Sub Process_Globals
	Public mqttlog As String							' log of MQTT messages
	Public mqttlog_nb As Byte	= 0						' nb lines in mqttlog
	Public mqttmessage As Boolean = False				' true = new message received
	Public mqttalarm As Byte = 0						' 0 = new alarm to highlignt
	Public mqttstatus As String = "MQTT not connected"	' MQTT status
	Public mqttworking As Boolean = False           	'start of MQTT after config loaded
	Private nid As Int = 1
	Private mqtt As MqttClient
	Private lock As PhoneWakeState
	Private timer1 As Timer
	Private timernb As Byte = 0							'nb of  phases 15sec 
	Private mqttserver As String = "host"
	Private mqttport As String = "port"
	Private mqttuser As String = "user"
	Private mqttpwd As String  = "pasword"
	Private mqttsubs As String = "subscribe"
	Private mqtttop As String = "topic"
	Private APKnb As String = "1"
	Private delay1 As Long     = 4						'nb of 15sec basic delay before next MQTT request 
	Private SOSsound As String = "8499.mp3"
	Private Log1 As String
	Private wait_mess As Boolean
	Private ala_key(25) As String
	Private ala_home(25) As String
	Private ala_perm(25) As String
	Private ala_lev1(25) As String
	Private ala_lev2(25) As String
	Public ala_level1 As Boolean
	Public ala_level2 As Boolean
	Public filepath As String
'	Public ala_last As String		'last alarme to highlight
End Sub

Sub Service_Create
	Service.AutomaticForegroundMode = Service.AUTOMATIC_FOREGROUND_NEVER 'we are handling it ourselves
	Service.StartForeground(nid, CreateNotification("...",False))
	Log("create service")
End Sub

Sub Service_Start (StartingIntent As Intent)
	lock.PartialLock
	CancelScheduledService(Me)
	Service.StopAutomaticForeground
	timer1.Initialize("timer1", 15000)
	timer1.Enabled = True
	Log("start service " & DateTime.time(DateTime.Now))
	Sleep(100)
	MQTTConnect
End Sub

Sub MQTTConnect
	Log1 = DateTime.time(DateTime.Now) & " no data"
	wait_mess = True
 	service_loadconfig
	If mqttworking = True Then
		If mqtt.IsInitialized Then mqtt.Close
'			Log(mqttserver&":"&mqttport)
		mqtt.Initialize("mqtt",(mqttserver&":"&mqttport), Rnd(0, 999999999 & DateTime.Now))
		Dim mo As MqttConnectOptions
		mo.Initialize(mqttuser, mqttpwd)
		Log("Trying to connect")
		mqttstatus ="Trying to connect"
		mqtt.Connect2(mo)
		Wait For mqtt_Connected (Success As Boolean)
		If Success Then
			mqtt.Subscribe(mqttsubs, 0)
'			Log("subscribe="&mqttsubs)
			Log("Mqtt connected")
			mqttstatus = "MQTT connected"
			Sleep(1000)
			mqtt_publish("request alarms")
		Else	
			Log("error MQTT connection")
			Log1 = DateTime.time(DateTime.Now) & " Network error"
			mqttstatus = "MQTT connection error"
		End If
	Else	
		mqttstatus = "MQTT data error"
		Log1 = DateTime.time(DateTime.Now) & " MQTT data error"
	End If
End Sub

public Sub mqtt_publish(body As String)     '(topic As String,body As String)
	Dim payload() As Byte
	Dim topic As String
	topic = mqtttop
	body = body &" from Mobile [ "&APKnb&" ]"
   	payload = body.getbytes("UTF8")
   	If mqtt.Connected = True Then 
    	mqtt.Publish(topic, payload)	
		Log("publish: topic="& topic &" payload=" & body)
		Log1 = (DateTime.time(DateTime.Now)& " RFGate no answer")
	End If
End Sub

Sub mqtt_MessageArrived (Topic As String, Payload() As Byte)
	Log1 = BytesToString(Payload,0,Payload.Length,"UTF-8")
	Dim log2 As String
	If Log1.Length > 31 Then log2 =Log1.substring2(8,29) 
	Log("Topic:" & Topic & " payload:" & Log1)
	Log1 = DateTime.time(DateTime.Now) & " " & BytesToString(Payload,0,Payload.Length,"UTF-8")
	For i = 0 To 24
		If ala_key(i) <> "" Then
			If Log1.Contains(ala_key(i)) Then 
				Log1= DateTime.time(DateTime.Now) & "  "& log2 & "  " & ala_home(i)
'				ala_last = Log1
				If ala_perm(i) = "1" Then 
					mqttalarm = Bit.Or(mqttalarm, 4)
					Log1 = Log1 & " => ALARM Perm detected"
				End If
				If ala_lev1(i) = "1" And ala_level1=True Then 
					mqttalarm = Bit.Or(mqttalarm, 1)
					Log1 = Log1 & " => ALARM L1 detected"
				End If
				If ala_lev2(i) = "1" And ala_level2=True Then
					mqttalarm = Bit.Or(mqttalarm, 2)
					Log1 = Log1 & " => ALARM L2 detected"
				End If
			Else
			   If Log1.Length > 110 Then
					Log1 = DateTime.time(DateTime.Now) & "  "& log2 & "  "& Log1.substring2(88,103)
				End If
			End If
		End If	
	Next
	If mqttalarm <> 0 Then play_notif(Log1)


	wait_mess = False		'end of wait for message
	add_log(Log1)
	add_logfile(Log1)
End Sub

 Sub service_loadconfig
	If File.Exists(File.DirInternal,"config.txt") Then
		Dim tr As TextReader
		Dim line As String
		tr.Initialize2(File.OpenInput(File.Dirinternal, "config.txt"), "UTF-8" )
		mqttserver = "tcp://"&tr.ReadLine
		mqttport   = tr.ReadLine
		mqttuser   = tr.ReadLine
		mqttpwd    = tr.ReadLine
		mqttsubs   = tr.ReadLine
		mqtttop   = tr.ReadLine
		APKnb   = tr.ReadLine
		delay1     = tr.ReadLine
		SOSsound   = tr.ReadLine
		tr.Close
		mqttworking = True
		Log("read OK")
	Else
		mqttworking = False
		Log("read NOK")
		ToastMessageShow("MQTT IP config NOK...", True)
	End If
	If Not (File.Exists(File.DirAssets,SOSsound)) Then SOSsound = "8499.mp3"
	
	If File.Exists(File.DirInternal,"homeconf.txt") Then
		tr.Initialize2(File.OpenInput(File.Dirinternal, "homeconf.txt"), "UTF-8" )
		Dim line As String
		For i = 0 To 24
			line = tr.ReadLine:If line <> Null Then ala_key(i) = line Else ala_key(i) = ""
		Next
		For i = 0 To 24
			line = tr.ReadLine:If line <> Null Then ala_home(i) = line Else ala_home(i) = ""
		Next
		For i = 0 To 24
			line = tr.ReadLine: If line <> Null Then ala_perm(i)= line Else ala_perm(i) = "0"
		Next	
		For i = 0 To 24
			line = tr.ReadLine: If line <> Null Then ala_lev1(i)= line Else ala_lev1(i) = "0"
		Next
		For i = 0 To 24
			line = tr.ReadLine: If line <> Null Then ala_lev2(i)= line Else ala_lev2(i) = "0"
		Next
		tr.close	
	End If
End Sub

Sub Timer1_Tick     
	'case no message received => we add message in log file
	If wait_mess = True Then 
		add_log(Log1)
		wait_mess = False
	End If
	'case service running without main application => service is closed
	If IsPaused(Main) = True Then
		serviceclose
		timernb = 0
	Else
	' case application active => service is not closed and request of alarm is done after a delay
		If timernb = delay1 Then	
			timernb = 0		'1mn
			If mqtt.Connected = False  Then
				Log(" new connect")
				 MQTTConnect
			Else
				Log(" new publish")
				mqtt_publish("request alarms")
			End If
		End If
		timernb = timernb + 1
	End If
End Sub

Sub add_log(log_1 As String)
	'case memory log limited at 30 lines
	If mqttlog_nb > 30 Then
		 mqttlog = mqttlog.SubString2(0,mqttlog.lastIndexOf(Chr(10)))
		' we remove one line at log file
	Else
		mqttlog_nb = mqttlog_nb + 1
	End If
	mqttlog= log_1 & CRLF & mqttlog
	mqttmessage = True	
	Log("log added "& DateTime.time(DateTime.Now))
End Sub

Sub add_logfile(log_1 As String)
	'case log file limited only by size of file
	If log_1.Contains("no new message") <> True Then
		Dim tr As TextWriter
		tr.Initialize2(File.OpenOutput(filepath, "logfile.txt" , True), "UTF-8" )
		tr.WriteLine(log_1)
		tr.close

		If File.Size(filepath, "logfile.txt") > 100000 Then
			If File.Exists(filepath, "logfile.bak") Then File.Delete(filepath, "logfile.bak")
			FileMove(filepath,"logfile.txt",filepath, "logfile.bak")
			Log("logfile swapp done "& DateTime.time(DateTime.Now))
		End If	
	End If	
End Sub

Sub FileMove(SourceFolder As String, SourceFile As String, TargetFolder As String, TargetFile As String) As Boolean
	Dim source, target As JavaObject
	source.InitializeNewInstance("java.io.File", Array(SourceFolder, SourceFile))
	target.InitializeNewInstance("java.io.File", Array(TargetFolder, TargetFile))
	Return source.RunMethod("renameTo", Array(target))
End Sub

Sub play_notif(s As String)
		Dim  sp2  As SoundPool
		Dim playID2,loadid2 As Int
		sp2.Initialize(1)
		loadid2= sp2.Load(File.DirAssets,SOSsound)
		Log("sound="& loadid2)
		Service.StartForeground(nid, CreateNotification(s,False))
		Sleep(250)
		Log("sound="& loadid2)
		playID2=sp2.Play(loadid2,1, 1, 1, 0, 1)
		Log("play="& playID2)
'		Sleep(4000)
End Sub	
	
Sub serviceclose	
'	timer1.Enabled = True
	CancelScheduledService(Me)
	If mqtt.IsInitialized Then mqtt.Close
	lock.ReleasePartialLock
	timer1.Enabled = False
'	Log("delay="&(delay1*15000))
	StartServiceAt("",DateTime.Now + (15000*delay1),True)
	Log("init next start OK  " & DateTime.time(DateTime.Now))
	StopService(Me)
End Sub

Sub CreateNotification (Body As String, Sound As Boolean) As Notification
	Dim notification As Notification
	notification.Initialize2(notification.IMPORTANCE_HIGH)
	notification.Icon = "icon"
	notification.Sound = Sound
	notification.vibrate = False
	notification.SetInfo("Tracking RF Alertes", Body, Main)
	Return notification
End Sub

Sub Service_Destroy
	mqttstatus = "MQTT in pause"
	lock.ReleasePartialLock
	Log("service stop")
End Sub

